#!/perl/bin/perl
#
# encode.pl 2009/1/24
# MP4XNvg
#
require 'define.pl';
$btsname = $ARGV[0];
$errname = $ARGV[1];
$ch = $ARGV[2];
if($ARGV[3] eq 0){ $RwIPOD = ""; }
system("$startCmd$TSConverter -r -l \"$btsname.ts\"");
unless(-f "$btsname.mp4"){	
	open(OT, ">$errname");
	close(OT);
}else{
	if($RwIPOD ne ""){
		if($iencM{$ch} eq 1){ $errf = &venc(); }
		elsif($iencM{$ch} eq 2){ $errf = &aenc(); }
		elsif($iencM{$ch} eq 3){ $errf = &vaenc(); }
		else{ &nenc(); }
		if($errf ne 0){ &nenc(); }
		unlink "$btsname.np1";
	}
}
unlink "$btsname.np";
unlink "$btsname.aac";
unlink "$btsname.264";
unlink "$btsname.ts";

sub nenc {
	open(OTK, ">$btsname.np1"); close(OTK);
	open(IN, "$startCmd$MP4Box -quiet -ipod -add $btsname.mp4 -new $btsname$RwIPOD.mp4 |");
	while(<IN>){}
	close(IN);
}

sub venc {
	local($Mp4Final) = @_;
	local($errf);
	$errf  = 0;
	open(OTK, ">$btsname.np3"); close(OTK);
	open(IN, "$startCmd$FFMpeg -threads 4 -i $btsname.mp4 -vcodec libx264 -s 320x180 -r 14.985015 -b 128000 -acodec copy -f ipod  $btsname$RwIPOD.mp4  |");
	while(<IN>){}
	close(IN);
	unlink "$btsname.np3";
	if(-f "$btsname$RwIPOD.mp4"){
		open(OTK, ">$btsname.np1"); close(OTK);
		open(IN, "$startCmd$MP4Box -quiet -ipod $btsname$RwIPOD.mp4 |");
		while(<IN>){}
		close(IN);
	}else{ $errf = 1; }
	return $errf;
}


sub aenc {
	local($errf);
	$errf  = 0;
	open(OTK, ">$btsname.np2"); close(OTK);
	system("$startCmd$AACDec -if $btsname.mp4 -of $btsname.wav");
	unlink "$btsname.np2";
	if(-f "$btsname.wav"){
		open(OTK, ">$btsname.np21"); close(OTK);
		system("$startCmd$AACEnc -br 64000 -if $btsname.wav -of $btsname.aactmp");
		unlink "$btsname.np21";
		unlink "$btsname.wav";
		if(-f "$btsname.aactmp"){
			open(OTK, ">$btsname.np22"); close(OTK);
			open(IN, "$startCmd$MP4Box -quiet -ipod -fps 14.985015 -add $btsname.264 -new $btsname$RwIPOD.mp4 |");
			while(<IN>){}
			close(IN);
			unlink "$btsname.np22";
			if(-f "$btsname$RwIPOD.mp4"){
				open(OTK, ">$btsname.np1"); close(OTK);
				open(IN, "$startCmd$MP4Box -quiet -ipod -add $btsname.aactmp  $btsname$RwIPOD.mp4 |");
				while(<IN>){}
				close(IN);
				unlink "$btsname.aactmp";
			}else{ $errf = 4; }
		}else{ $errf = 3; }
	}else{ $errf = 2; }
	return $errf;
}

sub vaenc {
	local($Mp4Final) = @_;
	local($errf);
	$errf  = 0;
	open(OTK, ">$btsname.np3"); close(OTK);
	open(IN, "$startCmd$FFMpeg -threads 4 -i $btsname.mp4 -vcodec libx264 -s 320x180 -r 14.985015 -b 128000 -f ipod $btsname$RwIPOD.mp4  |");
	while(<IN>){}
	close(IN);
	unlink "$btsname.np3";
	if(-f "$btsname$RwIPOD.mp4"){
		open(OTK, ">$btsname.np2"); close(OTK);
		system("$startCmd$AACDec -if $btsname.mp4 -of $btsname.wav");
		unlink "$btsname.np2";
		if(-f "$btsname.wav"){
			open(OTK, ">$btsname.np21"); close(OTK);
			system("$startCmd$AACEnc -br 64000 -if $btsname.wav -of $btsname.aactmp");
			unlink "$btsname.np21";
			unlink "$btsname.wav";
			if(-f "$btsname.aactmp"){
				if(-f "$btsname$RwIPOD.mp4"){
					open(OTK, ">$btsname.np1"); close(OTK);
					open(IN, "$startCmd$MP4Box -quiet -ipod -add $btsname.aactmp  $btsname$RwIPOD.mp4 |");
					while(<IN>){}
					close(IN);
					unlink "$btsname.aactmp";
				}else{ $errf = 4; }
			}else{ $errf = 3; }
		}else{ $errf = 2; }
	}else{ $errf = 1; }
	return $errf;
}

